# Get Builds

> Source: https://truto.one/docs/api-reference/unified-ci-cd-api/builds/get/

`GET /unified/ci-cd/builds/{id}`

Resource: **Builds** · API: **Unified CI/CD API**

## Supported integrations

Azure DevOps, Bitbucket, CircleCI, GitHub, Jenkins, Travis CI

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`workspace_id`** _(string)_
  The unique identifier for the workspace
- **`repo`** _(string)_
  The repository of the build
- **`workflow_id`** _(string)_
  The id of the workflow to filter the builds by.

## Response body

- **`id`** _(string, required)_
  The unique identifier for the build
- **`name`** _(string)_
  The name of the build
- **`repo`** _(string)_
  The repository of the build
- **`branch`** _(string)_
  The head branch of the build
- **`commit`** _(string)_
  The head commit of the build
- **`trigger`** _(string)_
  The trigger for the build - push, merge_request, api, cron, web or the raw response from the API
- **`triggered_by`** _(string)_
  The actor who triggered the build
- **`triggered_by_type`** _(string)_
  The type of the actor who triggered the build - user, bot or raw response from the API
- **`conclusion`** _(string)_
  The conclusion of the build - passed, failed, cancelled, timeout, skipped, retried, partial or the raw response from the API
- **`workflow`** _(string)_
  The workflow's unique identifier in the CI/CD
- **`build`** _(string)_
  The build's unique identifier in the CI/CD
- **`status`** _(string)_
  The status of the build - queued, in_progress, completed or the raw response from the API
- **`created_at`** _(string)_
  The date and time when the build was created
- **`updated_at`** _(string)_
  The date and time when the build was last updated
- **`started_at`** _(string)_
  The date and time when the build started
- **`completed_at`** _(string)_
  The date and time when the build finished
- **`attempts`** _(integer)_
  The number of attempts for the build
- **`number`** _(integer)_
  The run number of the build
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/ci-cd/builds/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/ci-cd/builds/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ci-cd/builds/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.get(
  'ci-cd',
  'builds',
  '<resource_id>',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.get(
        "ci-cd",
        "builds",
        "<resource_id>",
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
